# -*- coding: utf-8 -*-
# Generated by Django 1.9 on 2015-12-15 19:53
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Events',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('Timestamp', models.CharField(default='-', max_length=100)),
                ('Timestamp_Insertion', models.CharField(default='-', max_length=100)),
                ('Comment', models.TextField()),
            ],
        ),
        migrations.CreateModel(
            name='Ips',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('Ip', models.CharField(default='-', max_length=60)),
                ('Hostname', models.CharField(default='-', max_length=60)),
                ('Tag', models.CharField(default='-', max_length=255)),
            ],
        ),
        migrations.CreateModel(
            name='LogSources',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('Description', models.TextField()),
                ('Type', models.CharField(default='-', max_length=100)),
                ('Model', models.CharField(default='-', max_length=255)),
                ('Active', models.SmallIntegerField()),
                ('Software_Class', models.CharField(default='-', max_length=50)),
                ('Path', models.CharField(default='-', max_length=20)),
            ],
        ),
        migrations.CreateModel(
            name='Macs',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('MAC', models.CharField(default='-', max_length=17)),
                ('TAG', models.CharField(default='-', max_length=255)),
            ],
        ),
        migrations.CreateModel(
            name='PacketAdditionalInfo',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('Value', models.CharField(default='-', max_length=255)),
            ],
        ),
        migrations.CreateModel(
            name='Ports',
            fields=[
                ('id_port', models.IntegerField(primary_key=True, serialize=False)),
                ('Protocol', models.CharField(default='-', max_length=10)),
                ('Service', models.CharField(default='-', max_length=60)),
                ('Description', models.CharField(default='-', max_length=100)),
                ('Tag', models.CharField(default='-', max_length=25)),
            ],
        ),
        migrations.CreateModel(
            name='Tags',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('Description', models.TextField()),
                ('Tag', models.CharField(default='-', max_length=255)),
            ],
        ),
        migrations.CreateModel(
            name='PacketEventsInformation',
            fields=[
                ('Protocol', models.CharField(default='-', max_length=20)),
                ('RAW_Info', models.TextField(default='-')),
                ('TAG', models.CharField(default='-', max_length=255)),
                ('id', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, primary_key=True, serialize=False, to='secapp.Events', verbose_name='id_packet_events_information')),
                ('ID_Dest_MAC', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='mac_dest', to='secapp.Macs')),
                ('ID_Dest_Port', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='port_dest', to='secapp.Ports')),
                ('ID_IP_Dest', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='ip_dest', to='secapp.Ips')),
                ('ID_IP_Source', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='ip_source', to='secapp.Ips')),
                ('ID_Source_MAC', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='mac_source', to='secapp.Macs')),
                ('ID_Source_Port', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='port_source', to='secapp.Ports')),
            ],
        ),
        migrations.AddField(
            model_name='packetadditionalinfo',
            name='ID_Tag',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='id_tag', to='secapp.Tags'),
        ),
        migrations.AddField(
            model_name='events',
            name='ID_Source',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='secapp.LogSources'),
        ),
        migrations.AddField(
            model_name='packetadditionalinfo',
            name='ID_Packet_Events',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='id_packet_events', to='secapp.PacketEventsInformation'),
        ),
    ]
